import sys
from PyQt4 import QtCore, QtGui

class BatteryLevel(QtGui.QWidget):
  def __init__(self, parent):
    QtGui.QWidget.__init__(self, parent)
    self.device=self.parent().parent().device

    if self.device.hasBatteryStatus():
      (self.level, self.state)=self.device.getBatteryStatus()
      self.update_timer=QtCore.QTimer()
      self.connect(self.update_timer, QtCore.SIGNAL("timeout()"), self.refresh)
      self.update_timer.start(10000)
    else:
      self.level=-1
      self.state=-1

  def refresh(self):
    (self.level, self.state)=self.device.getBatteryStatus()
    self.update()

  def resizeEvent(self, e):
    h=e.size().height()
    w=(h/3)*2
    self.resize(w, h)
    self.setMinimumWidth(w)

  def paintEvent(self, e):
    w=self.width()
    h=self.height()
    
    ch=h/3
    
    painter=QtGui.QPainter(self)
    painter.drawRect(1, ch, w-4, ch)
    painter.fillRect(w-3, ch+ch/4, 3, ch/2+1, QtGui.QBrush(QtCore.Qt.black))
    if self.level!=-1:
      col_out=QtGui.QColor(255-self.level, self.level, 0)
      col_in=QtGui.QColor(255-self.level*2.5, self.level*2.5, 0)
      wl=self.level*(w-5)/100
      gradient=QtGui.QLinearGradient(0, 0, w, ch)
      gradient.setColorAt(0, col_out);
      gradient.setColorAt(0.5, col_in);
      gradient.setColorAt(1, col_out);
      gradient.setStart(0, ch)
      gradient.setFinalStop(0, ch*2)
      painter.setBrush(gradient);
      painter.setPen(QtCore.Qt.NoPen)
      painter.drawRect(2, ch+1, wl, ch-1)

    painter.end()
