from PyQt4 import QtCore, QtGui

from widget_menu import *
from battery_level import *
from system_monitor import *
from screen_button import *
from date_time import *
from close_button import *

class MenuBar(QtGui.QFrame):
  def __init__(self, parent):
    QtGui.QFrame.__init__(self, parent)

    self.layout=QtGui.QHBoxLayout(self)
    self.layout.setMargin(0)
    self.layout.setSpacing(0)
    
    self.widget_menu=WidgetMenu(self)
    self.system_monitor=SystemMonitor(self)
    self.battery_level=BatteryLevel(self)
    self.screen_button=ScreenButton(self)
    self.date_time=DateTime(self)
    self.close_button=CloseButton(self)
    self.close_button.setFixedWidth(self.height())


    self.layout.addWidget(self.widget_menu)
    self.layout.addStretch()
    self.layout.addWidget(self.system_monitor)
    self.layout.addWidget(self.battery_level)
    self.layout.addWidget(self.screen_button)
    self.layout.addWidget(self.date_time)
    self.layout.addWidget(self.close_button)

  def resizeEvent(self, e):
    self.close_button.setFixedWidth(self.height())

  def setCloseButtonEnabled(self, e):
    self.close_button.setEnabled(e)

  def selectWidget(self, w):
    self.widget_menu.selectWidget(w)

  def closeWidget(self, w):
    self.widget_menu.closeWidget(w)

  def updateWidgetIconTitle(self, w):
    self.widget_menu.updateWidgetIconTitle(w)

  def setWidgetVisibility(self, w, visibility):
    self.widget_menu.setWidgetVisibility(w, visibility)
