from PyQt4 import QtCore, QtGui

class WidgetMenu(QtGui.QPushButton):
  def __init__(self, parent):
    QtGui.QPushButton.__init__(self, parent)

    self.setFocusPolicy(QtCore.Qt.NoFocus)
    self.setFlat(1)
    self.setStyleSheet("text-align: left;")
    self.setMenu(QtGui.QMenu(self))

    self.current=None

    QtCore.QObject.connect(self.menu(), QtCore.SIGNAL("triggered(QAction*)"), self.widgetSelected)
    
  def widgetSelected(self, action):
    w=action.widget
    self.setIcon(w.widgetIcon())
    self.setText(w.widgetTitle())
    self.parent().parent().showWidget(w)

  def newWidget(self, w):
    self.setIcon(w.widgetIcon())
    self.setText(w.widgetTitle())
    a=WMQAction(self.menu(), w)
    self.current=a
    self.menu().addAction(a)

  def selectWidget(self, w):
    for a in self.menu().actions():
      if(a.widget is w):
        self.setIcon(a.widget.widgetIcon())
        self.setText(a.widget.widgetTitle())
        self.current=a
        return

    self.newWidget(w)

  def updateWidgetIconTitle(self, w):
    for a in self.menu().actions():
      if(a.widget is w):
        a.setIcon(w.widgetIcon())
        a.setText(w.widgetTitle())
        if(self.current is a):
          self.setIcon(w.widgetIcon())
          self.setText(w.widgetTitle())
        return

  def closeWidget(self, w):
    m=self.menu()
    for a in m.actions():
      if(a.widget==w):
        m.removeAction(a)
        break

  def setWidgetVisibility(self, w, visibility):
    for a in self.menu().actions():
      if(a.widget is w):
        a.setVisible(visibility)

class WMQAction(QtGui.QAction):
  def __init__(self, parent, w):
    QtGui.QAction.__init__(self, w.widgetIcon(), w.widgetTitle(), parent)
    self.widget=w
