from PyQt4 import QtCore, QtGui

from . import __path__
from core.auimd_widget import *

class VideoPlayer(QtGui.QLabel, AuimdWidget):
  @staticmethod
  def defaultWidgetIcon():
    return QtGui.QIcon(__path__[0]+"/icons/mplayer_32x32.png")

  @staticmethod
  def defaultWidgetTitle():
    return "MPlayer"

  @staticmethod
  def getCategory():
    return "Multimedia"

  def __init__(self, parent):
    QtGui.QLabel.__init__(self, parent)
    AuimdWidget.__init__(self, parent)

    self.setText("Ready")
    self.setAlignment(QtCore.Qt.AlignHCenter | QtCore.Qt.AlignVCenter)
    self.container=QtGui.QX11EmbedContainer(self)
    layout=QtGui.QVBoxLayout(self)
    layout.setMargin(0)
    layout.addWidget(self.container)

    self.left_button.setText("Play...")
    self.right_button.setText("Close")

    self.process=None

  def closeEvent(self, e):
    if(self.process):
      QtCore.QObject.disconnect(self.process, QtCore.SIGNAL("finished(int, QProcess::ExitStatus)"), self.finished)
      self.process.terminate()
      self.process.waitForFinished(3000)
      self.process.kill()

  def finished(self, exit_code, exit_status):
    #self.desktop.closeWidget(self)
    self.setText("Ready")
    pass

  def playVideo(self, filename):
    self.process=QtCore.QProcess(self)
    args=["-vo", "x11", "-wid", "%d" % self.container.winId(), filename]
    if self.width()<self.height():
      args.extend(["-vf", "rotate=2"])

    self.setText("Loading...")
    self.process.start("mplayer", args)

    if(self.process.waitForStarted()):
      QtCore.QObject.connect(self.process, QtCore.SIGNAL("finished(int, QProcess::ExitStatus)"), self.finished)
      self.setWidgetTitle(self.defaultWidgetTitle()+" - %d" % self.process.pid())
      self.setText("Playing...")
    else:
      self.setAutoFillBackground(1)
      self.setText("mplayer failed to start")
      self.process=None
      self.setWidgetTitle(self.defaultWidgetTitle()+" - error")
    
  def leftButtonAction(self):
    file=self.desktop.openFile(self)

    if(file):
      self.playVideo(file)

  def rightButtonAction(self):
    self.desktop.closeWidget(self)
