from PyQt4 import QtCore, QtGui, uic

from . import __path__
from core.auimd_widget import *

(Ui_Widgets, BaseClass) = uic.loadUiType(__path__[0]+"/ui/widgets.ui")

class Widgets(Ui_Widgets, BaseClass, AuimdWidget):
  @staticmethod
  def defaultWidgetIcon():
    return QtGui.QIcon(__path__[0]+"/icons/fileimport.png")

  @staticmethod
  def defaultWidgetTitle():
    return "Widgets"

  @staticmethod
  def getCategory():
    return "Settings"

  def __init__(self, parent):
    BaseClass.__init__(self, parent)
    AuimdWidget.__init__(self, parent)

    self.setupUi(self)

    self.widgets_directories=list(self.desktop.widgets_directories)
    for d in self.widgets_directories:
      if d!="widgets":
        self.directories.addItem(d)

    self.left_button.setText("Save")
    self.right_button.setText("Close")
    self.left_button.setEnabled(False)

  def leftButtonAction(self):
    self.desktop.widgets_directories=self.widgets_directories
    self.desktop.reloadWidgets()
    self.left_button.setEnabled(False)

  def rightButtonAction(self):
    self.desktop.closeWidget(self)

  def addDirectory(self):
    d=self.desktop.chooseDirectory(self)
    if d and d not in self.widgets_directories:
      self.widgets_directories.append(d)
      self.directories.addItem(d)
      self.left_button.setEnabled(True)

  def removeDirectories(self):
    for d in self.directories.selectedItems():
      self.widgets_directories.remove(d.text())
      self.directories.takeItem(self.directories.row(d))
      self.left_button.setEnabled(True)

  def onItemSelectionChanged(self):
    self.remove.setEnabled(len(self.directories.selectedItems())>0)
